#Some code is from the canola-flickr-plugin 
#License: GPL3

import flickrapi
import os
from wordpy import utils

API_KEY = 'c5c97bf7c85c7a5351cf9e1a2a433678'
API_SECRET = 'a20834f00befce6a'

def attributesFromDict(d, obj=None, objName="self"):
    '''see http://code.activestate.com/recipes/280381/'''
    if obj is None:
        obj = d.pop(objName)
    for n, v in d.iteritems():
        setattr(obj, n, v)

def authorize_on_flickr(widget):
    flickr = Flickr('')
    res = flickr.login()
    if not res == True:
        utils.show_info_dialog(widget, 'Press when authorize from flickr')
        res = flickr.login()
        if not res == True:
            utils.show_info_banner(widget, \
                            "Error, could not get access to a flickr account!")
            print "Error, could not get access to a flickr account!"
            return -1
    else:
        utils.show_info_banner(widget, "You already have allowed Flickr access")        

class Flickr:
    def __init__(self, username, api_key=API_KEY, api_secret=API_SECRET):
        attributesFromDict(locals())

        self.flickr = flickrapi.FlickrAPI(api_key, api_secret)
        self.logged = False
        self.token  = None
        self.frob   = None

    def login(self):
        if not self.frob and not self.token:
            token, self.frob = self.flickr.get_token_part_one(perms='write')
            if not token:
                self.token = None
                return False
            else: self.token = token

        self.token = self.flickr.get_token_part_two((self.token, self.frob))
        if not self.token:
            self.logged = False
        else: self.logged = True
        return self.logged

    def delete_token(self):
        import os
        token = os.path.join(os.path.expanduser("~"), ".flickr", self.api_key, \
                             "auth.token")

        if os.path.exists(token):
            os.unlink(token)
            return True
        else:
            return False

    def get_photolist(self, per_page, page):
        one_size = []
        one_width = []
        one_height = []
        one_url = []
        sizes = []		
        urls = []
        photos = []
        widths = []
        heights = []

        lista = self.flickr.photos_Search(user_id='me', per_page=per_page, \
                                          page=page)

        if int(lista.photos[0]['pages']) < int(page):
            print 'There isnt so much pages.'
            return None
		## try get more photos than there is, change perpage variable
        if int(lista.photos[0]['page'])*int(per_page) > int(lista.photos[0]['total']):
            perpage = int(lista.photos[0]['total']) - \
                    ((int(lista.photos[0]['page'])-1) * int(per_page))
        else:
            perpage = int(per_page)
        for i in range(perpage):
            del one_size[:]
            del one_width[:]
            del one_height[:]
            del one_url[:]			
            photos.append(lista.photos[0].photo[i]['title'])
            data = self.flickr.photos_getSizes(photo_id=lista.photos[0].photo[i]['id'])
            for psize in data.sizes[0].size:
                one_size.append(psize['label'])
                one_width.append(psize['width'])
                one_height.append(psize['height'])
                one_url.append(psize['source'])
            sizes.append(tuple(one_size))
            widths.append(tuple(one_width))			
            heights.append(tuple(one_height))
            urls.append(tuple(one_url))

        return photos, sizes, widths, heights, urls

    def upload(self, photos, filename_lb):
        #photos = [[filename, title, desc, tags, public, friend, family, [sets_id]]]
        for i in range(len(photos)): 
            filename_lb.set_text(os.path.basename(photos[i][0]))
            photo_id = self.flickr.upload(filename=photos[i][0], title=photos[i][1], \
                                    description=photos[i][2], tags=photos[i][3], \
                                    is_public=photos[i][4], is_friend=photos[i][5], \
                                    is_family=photos[i][6])
    
            upload_id = photo_id.photoid[0].text

            if photos[i][7] != []:
                for j in range(len(photos[i][7])):
                    self.flickr.photosets_addPhoto(photoset_id=photos[i][7][j], \
                                                photo_id=upload_id)

    def get_set_list(self):
        setlist = []
        lista = self.flickr.photosets_getList()
        
        for i in range(len(lista.photosets[0].photoset)):
            title = lista.photosets[0].photoset[i].title[0].text
            set_id = lista.photosets[0].photoset[i]['id']
            one_set = (set_id, title)
            setlist.append(one_set)
        
        return setlist
    
